//
//  L7SWebViewController.m
//  sdkdemo
//
//  Created by Anthony Yu on 2014-05-30.
//  Copyright (c) 2014 CA Technologies. All rights reserved.
//

#import "L7SWebViewController.h"
#import "L7SErrors.h"
#import "L7SHTTPClient.h"
#import "L7SClientManager.h"


@interface L7SWebViewController ()<UIScrollViewDelegate, UINavigationBarDelegate, UIGestureRecognizerDelegate, UIWebViewDelegate>{
        BOOL _hideStatusBar;
}

@end

@implementation L7SWebViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    //set the webView delegate
    self.webView.delegate = self;
    
    [self.app loadWebApp:self.webView];

    self.webView.scrollView.delegate=self;
    UITapGestureRecognizer *tapCatcher = [[UITapGestureRecognizer alloc] init];
    [tapCatcher setNumberOfTapsRequired:1];
    [tapCatcher setNumberOfTouchesRequired:1];
    [tapCatcher setDelegate:self];
    [tapCatcher addTarget:self action:@selector(tapped:)];
    
    [self.webView addGestureRecognizer:tapCatcher];
    

}


- (void) viewWillAppear:(BOOL)animated{
    [self.navigationController setToolbarHidden:NO animated:YES];
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)backButtonPressed:(id)sender {
    [self.webView goBack];
}
- (IBAction)forwardButtonPressed:(id)sender {
    [self.webView goForward];
}



/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (UIBarPosition)positionForBar:(id<UIBarPositioning>)bar{
    return UIBarPositionTopAttached;
}


- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView
{
	if (!_hideStatusBar) {
		[self hideBars];
	}
}

- (void)hideBars
{
	_hideStatusBar = YES;
    
	[UIView animateWithDuration:0.25 animations:^{
		[self setNeedsStatusBarAppearanceUpdate];
		self.navigationController.navigationBar.alpha = 0.0f;
		self.navigationController.toolbar.alpha = 0.0f;
	} completion:^(BOOL finished) {
        [self.navigationController setNavigationBarHidden:YES animated:YES];
        [self.navigationController setToolbarHidden:YES animated:YES];
	}];
}

- (BOOL)prefersStatusBarHidden
{
	return _hideStatusBar;
}

- (void)tapped:(UIGestureRecognizer *)recognizer
{
	if (recognizer.state == UIGestureRecognizerStateEnded && _hideStatusBar) {
		[self showBars];
	}
}


- (void)showBars
{
	_hideStatusBar = NO;
    
    [self.navigationController setNavigationBarHidden:NO animated:YES];
    [self.navigationController setToolbarHidden:NO animated:YES];
	[UIView animateWithDuration:0.25 animations:^{
		[self setNeedsStatusBarAppearanceUpdate];
		self.navigationController.navigationBar.alpha = 1.0f;
		self.navigationController.toolbar.alpha = 1.0f;
	}];
}

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer
{
    return YES;
}

# pragma mark UIWebView delegate implementation

- (void)webViewDidStartLoad:(UIWebView *)webView{
    NSLog(@"webViewDidStartLoad");
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType{
     NSLog(@"webView:shouldStartLoadWithRequest:navigationType:");
    return YES;
}

- (void)webViewDidFinishLoad:(UIWebView *)webView{
     NSLog(@"webViewDidFinishLoad");
}
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error{
    NSLog(@"webView:didFailLoadWithError");
}

@end
